#ifndef ESP32_STORAGE_HPP
#define ESP32_STORAGE_HPP

#include "Preferences.h"
#include "../Utils.hpp"

namespace fw
{
    class Storage
    {
    public:
        Storage();
        ~Storage();

    private:
        Preferences memory;

    protected:
        uint8_t retrieve_amount_of_rules();
        void store_amount_of_rules(const uint8_t new_amount);
        firewall_rule_t *retrieve_firewall_rule(const uint8_t key);
        void store_all_firewall_rules(firewall_rule_t *rule_head);
        void store_firewall_rule(firewall_rule_t *rule_ptr);
    };
}

#endif
